[LTP] [PATCH v6 02/10] controllers: Expand cgroup_lib shell library
Luke Nowakowski-Krijger
luke.nowakowskikrijger@canonical.com
Wed Jul 27 00:13:18 CEST 2022
Expand the cgroup_lib library by using the tst_cgctl binary
utility to make calls to the Cgroup C API to simplify and centralize the
mounting and cleanup process of Cgroups
Signed-off-by: Luke Nowakowski-Krijger <luke.nowakowskikrijger@canonical.com>
---
v5->v6: Added $ret to capture return code and added return $ret
after tst_brk calls.
testcases/kernel/controllers/cgroup_lib.sh | 137 ++++++++++++++++++---
1 file changed, 117 insertions(+), 20 deletions(-)
diff --git a/testcases/kernel/controllers/cgroup_lib.sh b/testcases/kernel/controllers/cgroup_lib.sh
index 56c9a7521..5fe2252be 100644
--- a/testcases/kernel/controllers/cgroup_lib.sh
+++ b/testcases/kernel/controllers/cgroup_lib.sh
@@ -2,38 +2,135 @@
# SPDX-License-Identifier: GPL-2.0-or-later
# Copyright (c) 2019-2022 Petr Vorel <pvorel@suse.cz>
# Copyright (c) 2018-2019 ARM Ltd. All Rights Reserved.
+# Copyright (c) 2022 Canonical Ltd.
-# Find mountpoint to given subsystem
-# get_cgroup_mountpoint SUBSYSTEM
-# RETURN: 0 if mountpoint found, otherwise 1
-get_cgroup_mountpoint()
+_cgroup_state=
+
+# Find mountpoint of the given controller
+# USAGE: cgroup_get_mountpoint CONTROLLER
+# RETURNS: Prints the mountpoint of the given controller
+# Must call cgroup_require before calling
+cgroup_get_mountpoint()
+{
+ local ctrl="$1"
+ local mountpoint
+
+ [ $# -eq 0 ] && tst_brk TBROK "cgroup_get_mountpoint: controller not defined"
+ [ "$_cgroup_state" = "" ] && tst_brk TBROK "cgroup_get_mountpoint: No previous state found. Forgot to call cgroup_require?"
+
+ mountpoint=$(echo "$_cgroup_state" | grep -w "^$ctrl" | awk '{ print $4 }')
+ echo "$mountpoint"
+
+ return 0
+}
+
+# Get the test path of a given controller that has been created by the cgroup C API
+# USAGE: cgroup_get_test_path CONTROLLER
+# RETURNS: Prints the path to the test direcory
+# Must call cgroup_require before calling
+cgroup_get_test_path()
+{
+ local ctrl="$1"
+ local mountpoint
+ local test_path
+
+ [ $# -eq 0 ] && tst_brk TBROK "cgroup_get_test_path: controller not defined"
+ [ "$_cgroup_state" = "" ] && tst_brk TBROK "cgroup_get_test_path: No previous state found. Forgot to call cgroup_require?"
+
+ mountpoint=$(cgroup_get_mountpoint "$ctrl")
+
+ test_path="$mountpoint/ltp/test-$$"
+
+ [ ! -e "$test_path" ] && tst_brk TBROK "cgroup_get_test_path: No test path found. Forgot to call cgroup_require?"
+
+ echo "$test_path"
+
+ return 0
+}
+
+# Gets the cgroup version of the given controller
+# USAGE: cgroup_get_version CONTROLLER
+# RETURNS: "1" if version 1 and "2" if version 2
+# Must call cgroup_require before calling
+cgroup_get_version()
{
- local subsystem=$1
- local mntpoint
+ local ctrl="$1"
+ local version
- [ $# -eq 0 ] && tst_brk TBROK "get_cgroup_mountpoint: subsystem not defined"
+ [ $# -eq 0 ] && tst_brk TBROK "cgroup_get_version: controller not defined"
+ [ "$_cgroup_state" = "" ] && tst_brk TBROK "cgroup_get_version: No previous state found. Forgot to call cgroup_require?"
- mntpoint=$(grep cgroup /proc/mounts | grep -w $subsystem | awk '{ print $2 }')
- [ -z "$mntpoint" ] && return 1
+ version=$(echo "$_cgroup_state" | grep -w "^$ctrl" | awk '{ print $2 }')
+ [ "$version" = "" ] && tst_brk TBROK "cgroup_get_version: Could not find controller $ctrl"
+
+ echo "$version"
- echo $mntpoint
return 0
}
-# Check if given subsystem is supported and enabled
-# is_cgroup_subsystem_available_and_enabled SUBSYSTEM
-# RETURN: 0 if subsystem supported and enabled, otherwise 1
-is_cgroup_subsystem_available_and_enabled()
+# Cleans up any setup done by calling cgroup_require.
+# USAGE: cgroup_cleanup
+# Can be safely called even when no setup has been done
+cgroup_cleanup()
{
- local val
- local subsystem=$1
+ [ "$_cgroup_state" = "" ] && return 0
- [ $# -eq 0 ] && tst_brk TBROK "is_cgroup_subsystem_available_and_enabled: subsystem not defined"
+ ROD tst_cgctl cleanup "$_cgroup_state"
- val=$(grep -w $subsystem /proc/cgroups | awk '{ print $4 }')
- [ "$val" = "1" ] && return 0
+ _cgroup_state=
- return 1
+ return 0
+}
+
+# Get the task list of the given controller
+# USAGE: cgroup_get_task_list CONTROLLER
+# RETURNS: prints out "cgroup.procs" if version 2 otherwise "tasks"
+# Must call cgroup_require before calling
+cgroup_get_task_list()
+{
+ local ctrl="$1"
+ local version
+
+ [ $# -eq 0 ] && tst_brk TBROK "cgroup_get_task_list: controller not defined"
+
+ version=$(cgroup_get_version "$ctrl")
+
+ if [ "$version" = "2" ]; then
+ echo "cgroup.procs"
+ else
+ echo "tasks"
+ fi
+
+ return 0
+}
+
+# Mounts and configures the given controller
+# USAGE: cgroup_require CONTROLLER
+cgroup_require()
+{
+ local ctrl="$1"
+ local ret
+
+ [ $# -eq 0 ] && tst_brk TBROK "cgroup_require: controller not defined"
+
+ [ ! -f /proc/cgroups ] && tst_brk TCONF "Kernel does not support control groups"
+
+ _cgroup_state=$(tst_cgctl require "$ctrl" $$)
+ ret=$?
+
+ if [ $ret -eq 32 ]; then
+ tst_brk TCONF "'tst_cgctl require' exited. Controller is probably not available?"
+ return $ret
+ fi
+
+ if [ $ret -ne 0 ]; then
+ tst_brk TBROK "'tst_cgctl require' exited."
+ return $ret
+ fi
+
+ [ "$_cgroup_state" = "" ] && tst_brk TBROK "cgroup_require: No state was set after call to tst_cgctl require?"
+
+ return 0
}
. tst_test.sh
--
2.34.1
More information about the ltp
mailing list